# -*- coding: utf-8 -*-

# Copyright 2006-2012 Borislav Rizov <bobyATdclDOTbasDOTbg>, Department of Computational Linguistic, Institute for Bulgarian Language – Bulgarian Academy of Sciences
# 
# This file is part of Chooser.
# 
# Chooser is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Chooser is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with Chooser.  If not, see <http://www.gnu.org/licenses/>.

from Tix import *

class PersistentModalDialog(Toplevel):
	def __init__(self,  master,  callback):
		Toplevel.__init__(self,  master)
		self.callback = callback
		body = Frame(self)
		body.pack()
		self.initial_focus = self.body(body)
		if self.initial_focus:
			self.initial_focus.focus_set()
			
		self.buttonbox() 
		self.protocol("WM_DELETE_WINDOW", self.cancel)
		self.withdraw()
	def body(self,  master):
		pass
	def buttonbox(self):
		'''add standard button box.

		override if you do not want the standard buttons
		'''

		box = Frame(self)

		w = Button(box, text="OK", width=10, command=self.ok, default=ACTIVE)
		w.pack(side=LEFT, padx=5, pady=5)
		w = Button(box, text="Cancel", width=10, command=self.cancel)
		w.pack(side=LEFT, padx=5, pady=5)

		self.bind("<Return>", self.ok)
		self.bind("<Escape>", self.cancel)

		box.pack()
#	def buttonbox(self):
#		self.button_box = ButtonBox(self)
#		self.button_box.grid(column = 0,  columnspan = 2,  sticky = EW)
#		self.button_box.add('ok', text = 'ok',  command = self.ok)
#		self.button_box.add('cancel', text = 'cancel',  command = self.cancel)
#		self.bind('<Escape>',  self.cancel)
	def show(self):
		self.deiconify()
		self.transient(self.master)
		self.grab_set()
		self.initial_focus.focus_set()
	def ok(self,  event = None):
		if self.validate() and self.callback(self):
			self.cancel()
	def cancel(self, event = None):
		self.withdraw()
		self.master.grab_set()
	def validate(self):
		return True
if __name__ == '__main__':
	x = Tk()
	tl = PersistentModalDialog(x,  None)
	def cmd():
		tl.show()
	Button(text = 'test',  command = cmd).pack()
	x.mainloop()
