# -*- coding: utf-8 -*-

# Copyright 2006-2012 Borislav Rizov <bobyATdclDOTbasDOTbg>, Department of Computational Linguistic, Institute for Bulgarian Language – Bulgarian Academy of Sciences
# 
# This file is part of Chooser.
# 
# Chooser is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Chooser is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with Chooser.  If not, see <http://www.gnu.org/licenses/>.

from dialog import PersistentModalDialog
from Tix import *

class FindDialog(PersistentModalDialog):
	def body(self,  master):
		self.title('Find')
		
		Label(master,  text = 'word:').grid(padx = 10,  row = 0,  sticky = E)
		self.entry = Entry(master)
		self.entry.grid(padx = 5,  row = 0,  column = 1,  sticky = W)
		self.v = IntVar()
		self.form_radio = Radiobutton(master,  text = 'form',  variable = self.v,  value = 0, anchor = W)
		self.form_radio.grid(column = 0,  sticky = W,  padx = 10)
		self.lemma_radio = Radiobutton(master,  text = 'lemma',  variable = self.v,  value = 1,  anchor = W)
		self.lemma_radio.grid(column = 0,  sticky = W,  padx = 10)
		
		self.form_radio.select()
		
		
		self.backword_v = IntVar()
		self.backward_checkbox = Checkbutton(master,  text = 'search backwards',  variable = self.backword_v,  anchor = W)
		self.backward_checkbox.grid(column = 1,  row = 1,  stick = W,  padx = 10)
		
		self.case_sensitive_v = IntVar()
		self.case_checkbox = Checkbutton(master,  text = 'case sensitive',  variable = self.case_sensitive_v)
		self.case_checkbox.grid(column = 1,  row = 2,  sticky = W,  padx = 10)
		
		return self.entry

	def validate(self):
		return bool(self.value())
	
	def value(self):
		return self.entry.get()
		
	def by_lemma(self):
		return self.v.get()
		
	def direction(self):
		return self.backword_v.get()
		
	def case_sensitive(self):
		return self.case_sensitive_v.get()

if __name__ == '__main__':
	x = Tk()
	tl = FindDialog(x,  None)
	def cmd():
		tl.show()
	Button(text = 'test',  command = cmd).pack()
	x.mainloop()
