# -*- coding: utf-8 -*-

# Copyright 2006-2012 Borislav Rizov <bobyATdclDOTbasDOTbg>, Department of Computational Linguistic, Institute for Bulgarian Language – Bulgarian Academy of Sciences
# 
# This file is part of Chooser.
# 
# Chooser is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Chooser is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with Chooser.  If not, see <http://www.gnu.org/licenses/>.

from Tkinter import *
from Tix import ScrolledText
#import Pmw
#from undo_controler import *
from hydra.observer_context import *
from tkLinkManager import SelectManager
import tkFont
import time

class TextView(Context, Frame):
	def create_widgets(self):
		self.text_frame = ScrolledText(self, scrollbar='y',  options = 'bg "ivory"')
		self.text_frame.pack(expand = 1, fill = BOTH)

		self.text_box = self.text_frame.text
		self.text_box['bg'] = 'ivory'
		self.text_box['state'] = DISABLED
		self.text_box['wrap'] = WORD
		self.font = tkFont.Font(family = 'Courier',  size = -12)
#		self.font = tkFont.Font(self.text_box['font'])
#		self.text_box['font'] = self.font
		self.text_box["width"] = 50

		proba = 'това е проба.@!'
		self.charwidth = self.font.measure(proba) / len(proba)
#		print dir(self.text_box)
		
		self.select_manager = SelectManager(self.text_box)
		
#		self.winfo_toplevel().bind_all('<Left>',  self.prev)
		self.winfo_toplevel().bind('<Left>',  self.prev)
		self.winfo_toplevel().bind('<Right>',  self.next)
	def __init__(self, parent, master):
		Context.__init__(self)
		Frame.__init__(self, parent)
		self.master = master
		self.create_widgets()
	def refresh(self, message = None):
		if message and (message.type & VM.Edit):
			self.draw()
		self.set_current()
#		print self.model._current
		#NB
		self.notify(VMessage(self.model.current()))
	def set_current(self):
#		print 'set_current'
		current = self.model.current()
		self.select_manager.highlight(current)
#		self.text_box.see(current.tags()[0] + '.first') 
	def word_width(self,  word):
		return len(word.word) * self.charwidth
	def draw_text(self):
		max_width = self.text_box.winfo_width()
		max_width = int(self.text_box['width']) * self.charwidth + 50
#		print max_width,  self.charwidth*int(self.text_box['width'])
		width = 0
		for i,  w in enumerate(self.model.words):
#			print 'adding',  w.tag,  w.word.encode('utf8')
			if i > 0 and 'CLIPPING' in w.word.upper(): #TODO:make it in a different way!
				self.text_box.insert(END, '\n\n')
			ww = self.word_width(w)
			width += ww + self.charwidth
#			print width,  'width',  max_width
			if width > max_width:
#				print 'ins'
				self.text_box.insert(END,  '\n')
				width = ww
			else:
				self.text_box.insert(END, ' ')
			self.text_box.insert(END,  w.word,  self.select_manager.add(
				lambda shift,  ww = w: 
				self.on_select(ww,  shift),  w.tag))
			#Uncomment for total colorising
			#self.select_manager.colorise(w) 
	def draw(self):
		begin = time.time()
		self.text_box['state'] = NORMAL
		self.text_box.delete('1.0', 'end')
		self.select_manager.reset()
		self.draw_text()
		self.text_box['state'] = DISABLED
		end = time.time()
		print 'draw',  end - begin
		self.refresh()
	def on_select(self,  word,  shift):
#		print 'select',  word.literal(),  shift
		if self.model.is_selected(word):
			self.model.deselect(word,  shift)
		else:
			self.model.select(word,  shift)
		self.refresh()
	def find(self,  word,  case_sensitive,  direction):
		res = self.model.find(word,  case_sensitive,  direction)
		self.refresh()
		return res
	def move(self,  direction):
		self.model.move(direction)
		self.refresh()
	def prev(self,  event = None):
		self.move(self.model.BACKWORD)
	def next(self,  event = None):
		self.move(self.model.FORWARD)
	def set_model(self, model):
		self.model = model
		self.draw()

