from Tix import *
from common import *

class UndoControler(Frame):
	def __init__(self, parent, history, rd = "redo", ud = "undo"):
		Frame.__init__(self, parent)
		self.history = history
		#parent.add_command(label = "redo", command = self.redo, state = "disabled")
		#parent.add_command(label = "undo", command = self.undo, state = "disabled")
		self.redo_button = Button(self, text = rd, command = self.redo, state = "disabled")
		self.undo_button = Button(self, text = ud, command = self.undo, state = "disabled")
		self.undo_button.pack(side = "left")
		self.redo_button.pack(side = "left")
		self.history.attach(self)
# 		self.refresh(None)
	def refresh_buttons(self):
		if self.history.possible_undo():
			self.undo_button["state"] = "normal"
		else:
			self.undo_button["state"] = "disabled"
		if self.history.possible_redo():
			self.redo_button["state"] = "normal"
		else:
			self.redo_button["state"] = "disabled"
	def message(self, data):
		showinfo("", data)
	def refresh(self, data, senders):
		#if data:
			#self.message(data)
		#else:
		self.refresh_buttons()
	def undo(self):
		self.history.undo()
	def redo(self):
		self.history.redo()
		
